<%@ language="JScript" %>
<%
	// POST.ASP - Server script for upload.exe
	// Copyright (c) 2004, Nol Danjou <http://noeld.com>
	//
	// This script was written as an accompanying sample for 
	// my upload program (http://noeld.com/programs.asp#upload)
	// (For better performances, use an actual upload component.)
	//
	// Syntax:
	//   upload.exe <localfile.ext> <url>/post.asp?vpath=<serverpath>/file.ext /post
	//
	// Return codes:
	//  400  Invalid syntax. vpath is missing or is empty.
	//  500  Internal server error. The vpath is invalid.

	// Build the path of the target file on the server
	var vpath = String(Request("vpath"));
	
	if (vpath == "undefined" || vpath == "")
	{
		Response.Status = "400 invalid syntax";
	}
	else
	{
		// Increase Script Timeout to 10 hours
		Server.ScriptTimeout = 36000;


		// Read the POST data as 4K chunks
		var adTypeBinary = 1;
		var adSaveCreateNotExist = 1;
  		var adSaveCreateOverWrite = 2;
  
		var BinaryStream = Server.CreateObject("ADODB.Stream");
		var toRead = Request.TotalBytes;
    	var readSize = 4096;

		BinaryStream.Type = adTypeBinary;
		BinaryStream.Open();

		while (toRead > 0)
		{
			var postData = Request.BinaryRead(readSize);
			BinaryStream.Write(postData);

			toRead -= readSize;
			
			if (readSize > toRead)
				readSize = toRead;
		}

		// Write the file to the virtual path
		var fileName = Server.MapPath(vpath);

		BinaryStream.Position = 0;
		BinaryStream.SaveToFile(fileName, adSaveCreateOverWrite);
		BinaryStream.Close();
	}
%>